#pragma once

#include "ofMain.h"
#include <array>

class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);

        void handleKeys();
        void stopBall();
        void startBall();
        void resetBall();

private:

    float fpsAdjusted(float) const;
    void checkPaddleCollision();
    void checkWallCollision();

    const float target_fps = 60;
    ofColor bg_color;
    ofTrueTypeFont scoreFont;

    float xpos, ypos;
    float xspeed, yspeed;
    float left_paddle_pos, right_paddle_pos;
    double frame_rate_multip;
    int p1Score;
    int p2Score;

    std::set<int> keySet;
};
